"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var assert_1 = __importDefault(require("assert"));
var webpack_sources_1 = require("webpack-sources");
// eslint-disable-next-line @typescript-eslint/no-var-requires
var version = require('../package').version;
var isJsFile = /\.js$/i;
var pluginName = 'esbuild-minify';
// eslint-disable-next-line unicorn/no-fn-reference-in-iterator
var flatMap = function (array, cb) { return array.flatMap ? array.flatMap(cb) : [].concat.apply([], array.map(cb)); };
function isWebpack5(compilation) {
    return compilation.hooks.processAssets !== undefined;
}
var ESBuildMinifyPlugin = /** @class */ (function () {
    function ESBuildMinifyPlugin(options) {
        this.options = __assign({}, options);
        var hasMinify = Object.keys(this.options).some(function (k) {
            return k.startsWith('minify');
        });
        if (!hasMinify) {
            this.options.minify = true;
        }
    }
    ESBuildMinifyPlugin.prototype.apply = function (compiler) {
        var _this = this;
        compiler.hooks.compilation.tap(pluginName, function (compilation) {
            assert_1.default(compiler.$esbuildService, '[esbuild-loader] You need to add ESBuildPlugin to your webpack config first');
            var meta = JSON.stringify({
                name: 'esbuild-loader',
                version: version,
                options: _this.options,
            });
            compilation.hooks.chunkHash.tap(pluginName, function (_, hash) {
                return hash.update(meta);
            });
            if (isWebpack5(compilation)) {
                compilation.hooks.processAssets.tapPromise({
                    name: pluginName,
                    stage: compilation.constructor.PROCESS_ASSETS_STAGE_OPTIMIZE_SIZE,
                }, function (assets) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                    return [2 /*return*/, this.transformAssets(compilation, Object.keys(assets))];
                }); }); });
                compilation.hooks.statsPrinter.tap(pluginName, function (stats) {
                    stats.hooks.print
                        .for('asset.info.minimized')
                        .tap(pluginName, function (minimized, _a) {
                        var green = _a.green, formatFlag = _a.formatFlag;
                        return minimized ? green(formatFlag('minimized')) : undefined;
                    });
                });
            }
            else {
                compilation.hooks.optimizeChunkAssets.tapPromise(pluginName, function (chunks) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        return [2 /*return*/, this.transformAssets(compilation, flatMap(chunks, function (chunk) { return chunk.files; }))];
                    });
                }); });
            }
        });
    };
    ESBuildMinifyPlugin.prototype.transformAssets = function (compilation, assetNames) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, devtool, $esbuildService, sourcemap, transforms;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = compilation.compiler, devtool = _a.options.devtool, $esbuildService = _a.$esbuildService;
                        assert_1.default($esbuildService, '[esbuild-loader] You need to add ESBuildPlugin to your webpack config first');
                        sourcemap = (
                        // TODO: drop support for esbuild sourcemap in future so it all goes through WP API
                        this.options.sourcemap === undefined ?
                            devtool && devtool.includes('source-map') :
                            this.options.sourcemap);
                        transforms = assetNames
                            .filter(function (assetName) { return isJsFile.test(assetName); })
                            .map(function (assetName) { return [
                            assetName,
                            compilation.getAsset(assetName),
                        ]; })
                            .map(function (_a) {
                            var assetName = _a[0], _b = _a[1], info = _b.info, assetSource = _b.source;
                            return __awaiter(_this, void 0, void 0, function () {
                                var _c, source, map, result;
                                return __generator(this, function (_d) {
                                    switch (_d.label) {
                                        case 0:
                                            _c = assetSource.sourceAndMap(), source = _c.source, map = _c.map;
                                            return [4 /*yield*/, $esbuildService.transform(source.toString(), __assign(__assign({}, this.options), { sourcemap: sourcemap, sourcefile: assetName }))];
                                        case 1:
                                            result = _d.sent();
                                            compilation.updateAsset(assetName, 
                                            // @ts-expect-error
                                            sourcemap ?
                                                new webpack_sources_1.SourceMapSource(result.code || '', assetName, result.map, source === null || source === void 0 ? void 0 : source.toString(), map, true) :
                                                new webpack_sources_1.RawSource(result.code || ''), __assign(__assign({}, info), { minimized: true }));
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        });
                        if (!(transforms.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, Promise.all(transforms)];
                    case 1:
                        _b.sent();
                        _b.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    return ESBuildMinifyPlugin;
}());
exports.default = ESBuildMinifyPlugin;
